GroupAssignmentOne/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('homepage.urls')),
    path('voucher/',include('Voucher.urls')),
    path('productpage/',include('ProductPage.urls')),
    path('buy/', include('transaction.urls'))
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

Voucher/urls.py
from django.urls import path, include
from django.conf.urls import url
from . import views
from .models import Voucher

app_name = 'Voucher'

urlpatterns = [
    
    path('', views.voucher, name='voucher')
]

transaction/urls.py
from django.urls import path, include
from django.conf.urls import url
from . import views

app_name = 'transaction'

urlpatterns = [
    path('', views.index, name='index'),
    path('thanks/', views.thanks, name="thanks"),
    path('history/', views.history, name="history")
]

transaction/models.py
from django.db import models

# Create your models here.

class Transaction(models.Model):
    buyer = models.CharField(max_length=50)
    item = models.ForeignKey('homepage.Items', on_delete=models.CASCADE)
    voucher = models.ForeignKey('Voucher.Voucher', on_delete=models.CASCADE, blank=True, null=True)
    total_price = models.IntegerField()
    date = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return "{}: {}".format(self.buyer, str(self.item))

transaction/forms.py
from django import forms
from homepage.models import Items
from .models import Transaction
from Voucher.models import Voucher

class AddTransaction(forms.ModelForm):
    class Meta:
        model = Transaction
        fields = {
            'buyer',
            'item',
            'voucher',
            'total_price'
        }

    item_id = forms.CharField(max_length=6)
    voucher_name = forms.CharField(max_length=20)

    def __init__(self, *args, **kwargs):
        super(AddTransaction, self).__init__(*args, **kwargs)
        self.fields['item'].required = False
        self.fields['voucher'].required = False
        self.fields['total_price'].required = False

    def clean(self):
        item = self.cleaned_data.get('item_id')
        if not item:
            raise forms.ValidationError("Item does not exist!")
        
        item = Items.objects.get(id=item)
        self.cleaned_data['total_price'] = item.price

        self.cleaned_data['voucher'] = None
        voucher = self.cleaned_data.get('voucher_name')
        if voucher:
            voucher = Voucher.objects.get(code_name=voucher)
            self.cleaned_data['voucher'] = voucher
            self.cleaned_data['total_price'] = (item.price*voucher.price_cut)//100

        return super(AddTransaction, self).clean()

transaction/views.py
from django.shortcuts import render, redirect
from django.contrib import messages
from django.core import validators
from django.urls import reverse
from django.db.models import Q
# from django.contrib.postgres.search import SearchVector
from homepage.models import Items, Category
from homepage.views import build_url
from Voucher.models import Voucher
from .models import Transaction
from .forms import AddTransaction
import datetime
# code_name, price_cut, minimum_price, expired_date


# Create your views here.
def index(request):
    context = {
        'nav': [
            [build_url('homepage:index'), 'HOME'],
            [build_url('homepage:category'), 'CATEGORY'],
            [build_url('Voucher:voucher'), 'VOUCHERS'],
            [build_url('transaction:history'), 'HISTORY']
        ],
    }

    if request.method == 'GET':
        if request.GET.get('item_id'):
            try:
                item = Items.objects.get(id=request.GET.get('item_id'))
            except Items.DoesNotExist:
                return redirect(build_url('homepage:index'))
            
            context['item'] = item
            context['item_price'] = item.price
            context['item_id'] = item.id
            context['voucher'] = None
            return render(request, 'buy.html', context)
    elif request.method == 'POST':
        context['voucher'] = None
        item = Items.objects.get(id=request.POST.get('item_id'))
        if not request.POST.get('buy') and request.POST.get('voucher'):
            try:
                voucher = Voucher.objects.get(code_name='voucher')
                if datetime.datetime.now() > voucher.expired_date or item.price < voucher.minimum_price:
                    raise Voucher.DoesNotExist

                context['item_price'] = item.price*voucher.price_cut//100
            except Voucher.DoesNotExist:
                return render(request, 'buy.html', context)

            context['item_id'] = item.id
            return render(request, 'buy.html', context)
        elif request.POST.get('buy') == 'TRUE':
            attribute = request.POST
            attribute.pop('buy')

            form = AddTransaction(attribute)
            if form.is_valid():
                form.save()
                return redirect(build_url('transaction:thanks'))            
    
    return redirect(build_url('homepage:index'))

def thanks(request):
    context = {
        'nav': [
            [build_url('homepage:index'), 'HOME'],
            [build_url('homepage:category'), 'CATEGORY'],
            [build_url('Voucher:voucher'), 'VOUCHERS'],
            [build_url('transaction:history'), 'HISTORY']
        ],
    }
    return render(request, 'thanks.html', context)
    

def history(request):
    trans = Transaction.objects.all()

    context = {
        'nav': [
            [build_url('homepage:index'), 'HOME'],
            [build_url('homepage:category'), 'CATEGORY'],
            [build_url('Voucher:voucher'), 'VOUCHERS'],
            [build_url('transaction:history'), 'HISTORY']
        ],
        'history': trans,
    }

    return render(request, 'history.html', context)

transaction/templates/base.html
<!doctype html> {%load static%}
<html lang="en">

<head>

    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">

    <!-- Home CSS -->
    <link rel="stylesheet" href="{% static 'style.css' %}">

    <!-- Font Link -->
    <link href="https://fonts.googleapis.com/css?family=Oswald|Playfair+Display&display=swap" rel="stylesheet">

    <title>stackovershoes</title>

</head>

<body>

    <nav class="navbar navbar-expand-lg navbar-dark bg-dark sticky-top">
        <div class="container">
            <a class="navbar-brand" href="#">
                <img src="stackovershoes-logo-white.png" width="40" height="40" alt="">
            </a>
            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarTogglerDemo02" aria-controls="navbarTogglerDemo02" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
        </button>
            <form class="form-inline my-2 my-lg-0">
                <input class="form-control mr-sm-2 nav-font" type="search" placeholder="Search">
            </form>
            <div class="collapse navbar-collapse" id="navbarTogglerDemo02">
                <ul class="navbar-nav ml-auto">
                    {% for link, nav in nav %}
                    <li class="nav-item active">
                        <a class="nav-link nav-font" href="{{link}}"><b>{{nav}}</b></a>
                    </li>
                    {% endfor %}
                </ul>
            </div>
        </div>
    </nav>

    {% block content %}{% endblock %}

</body>


<!-- Optional JavaScript -->
<!-- jQuery first, then Popper.js, then Bootstrap JS -->
<script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>

</html>

transaction/templates/buy.html
{% extends "base.html" %} {% load static %} {% block content %}

<div class="container text-center" style="margin-top:20px; align-self: center; align-items: center; justify-self: center; justify-content: center;">

    <div class="row">

        <div class="col-md-auto" style="text-align: left;">
            <div class="details">
                <u>DETAILS</u>
            </div>
            <div class="product-details-cart">
                <br>
                <p>1x {{item.name}} </p>
                <p>{{item.description}}</p>
            </div>
        </div>

        <div class="col">

            <div class="card" style="width: 18rem; text-align: left;">
                <div class="card-body">
                    <h5 class="card-title details" style="margin-top: 5px;">VOUCHERS</h5>
                    <forms method='POST'>
                        <input type="text" class="form-control" placeholder="Enter Here" aria-label="Voucher Code" name="voucher">
                        <input type="hidden" value="{{item_id}}" name="item_id">
                    </forms>
                </div>
            </div>

            <div class="card" style="width: 18rem; margin-top: 20px;">
                <div class="card-body">
                    <h5 class="card-title details">NAME</h5>
                    <forms method='POST'>
                        <input type="text" class="form-control" placeholder="Enter Your Name Here" aria-label="Name" name="buyer">
                        <input type="hidden" value="TRUE" name="buy">
                        <input type="hidden" value="{{item_id}}" name="item_id" required id="id_items_id">
                        <input type="hidden" value="{{voucher}}" name="voucher" required id="id_voucher">
                        <h5 class="card-title total">TOTAL AMOUNT</h5>
                        <h6 class="card-subtitle mb-2 text-muted amount">{{item_price}}</h6>
                        <input type="submit" class="btn btn-dark back-to-shopping" value="PAY">
                    </forms>
                </div>
            </div>
        </div>
    </div>
</div>

{%endblock%}

transaction/templates/thanks.html
<!doctype html>
<html lang="en">

<head>

    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">

    <!-- Home CSS -->
    <link rel="stylesheet" href=style.css>

    <!-- Font Link -->
    <link href="https://fonts.googleapis.com/css?family=Oswald|Playfair+Display&display=swap" rel="stylesheet">

    <title>stackovershoes</title>

</head>

<body>

    <nav class="navbar navbar-expand-lg navbar-dark bg-dark sticky-top">
        <div class="container">
            <a class="navbar-brand" href="#">
                <img src="stackovershoes-logo-white.png" width="40" height="40" alt="">
            </a>
            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarTogglerDemo02" aria-controls="navbarTogglerDemo02" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
        </button>
            <form class="form-inline my-2 my-lg-0">
                <input class="form-control mr-sm-2 nav-font" type="search" placeholder="Search">
            </form>
            <div class="collapse navbar-collapse" id="navbarTogglerDemo02">
                <ul class="navbar-nav ml-auto">
                    {% for link, nav in nav %}
                    <li class="nav-item active">
                        <a class="nav-link nav-font" href="{{link}}"><b>{{nav}}</b></a>
                    </li>
                    {% endfor %}
                </ul>
            </div>
        </div>
    </nav>

    <div class="container thanks">
        <h1>THANKS FOR SHOPPING WITH US</h1>
        <button type="button" class="btn btn-dark">
          <a href="#" class="back-to-shopping">BACK TO SHOPPING</a>
        </button>
    </div>

</body>


<!-- Optional JavaScript -->
<!-- jQuery first, then Popper.js, then Bootstrap JS -->
<script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>

</html>